Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2323 by niro, Fri Jan 3 13:19:11 2014 UTC revision 2434 by niro, Tue Jan 7 14:20:31 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/installer/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
18    
19  ### System/Config Version  die()
20  VERSION="%VERSIONTAG%"  {
21  TITLE="Installer - ${VERSION}"   echo "Error: $@"
22     exit 1
23    }
24    
25  CDPATH="/mnt/cdrom"  # load common includes
26  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
31     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
32     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
33    do
34     if [ -e ${inc} ]
35     then
36     source "${inc}"
37     else
38     die "'${inc}' not found"
39     fi
40    done
41    
42  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
43    # -> now in images.conf
44    CDIMAGENAME=""
45    TOTALLINES=""
46  CURRENTLINE=0  CURRENTLINE=0
47  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
48    then
49     source /mnt/cdrom/system/images.conf
50     # check if all required variables are set
51     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
52     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
53    else
54     die "/mnt/cdrom/system/images.conf not found"
55    fi
56    
57  # standard kernel opts  ### System/Config Version
58  KERNELOPTS="quiet video=1024x768"  VERSION="%VERSIONTAG%"
59    TITLE="${DEFAULT_TITLE} - ${VERSION}"
60    
61  # grub options  # some sane defaults
62    CDROOT="${DEFAULT_CDROOT}"
63    INSTALLROOT="${DEFAULT_INSTALLROOT}"
64    KERNELPKG="${DEFAULT_KERNELPKG}"
65    KERNELOPTS="${DEFAULT_KERNELOPTS}"
66  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
67  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
68  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
69  SPECIALDEVICE=""  SPECIALDEVICE=""
70  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
71    FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
72    
73  #################################################  #################################################
74  #  DIALOG BOXEN #  #  DIALOG BOXEN #
75  #################################################  #################################################
76    
77  die()  trap_exit()
78    {
79     is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84    
85     echo $"Installation aborted."
86     exit 1
87    }
88    
89    dialog_die()
90  {  {
91   ERROR=$1   ERROR="$1"
92   RETVAL=$?   RETVAL="$?"
93   dialog_install_failure   dialog_install_failure
94   exit 1   exit 1
95  }  }
96    
97  dialog_warning()  dialog_warning()
98  {  {
99   dialog \   local retval
100   --backtitle "${TITLE}" \  
101   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
102   --defaultno \   retval=$?
103   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
104   then   then
105   clear   clear
106   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
107   exit 1   exit 1
108   fi   fi
109  }  }
110    
111  dialog_setup_hdd_info()  dialog_setup_hdd_info()
112  {  {
113   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
114    
115   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
116   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
117  }  }
118    
119  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
120  {  {
121   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
122    
123   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
124   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
125  }  }
126    
127  dialog_setup_system_menu()  dialog_setup_system_menu()
128  {  {
129   local i   local mode
130     local retval
131    
132   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
133   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
134   --title "[ Festplatten Partitionierung ]" \   ":" \
135   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
136   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
137   --stdout \   retval=$?
138   --colors \   [[ ${retval} -eq 1 ]] && return 1
139   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
140   then   then
141   case "${i}" in   case "${mode}" in
142   "1") run_install_auto ;;   "1") run_install_auto ;;
143           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
144   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
145   esac   esac
146   fi   fi
# Line 149  dialog_setup_system_menu() Line 148  dialog_setup_system_menu()
148    
149  dialog_hardware_detection()  dialog_hardware_detection()
150  {  {
151   local i   local message
  local hwtmp  
152    
153   if [ -x $(which mktemp &> /dev/null) ]   run_hardware_detection_disks
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
154    
155   [[ ! -z ${installdevs} ]] && installdevs=""   message+=$"Harddrives:\n"
156    
157   echo "dialog \\"  > ${hwtmp}   if [[ ! -z ${ALL_DISKS} ]]
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
   
  if [[ ! -z ${scsidisks} ]]  
158   then   then
159   for i in ${scsidisks}   for i in ${ALL_DISKS}
160   do   do
161   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
162   done   done
163     message+="\n"
164   fi   fi
165    
166   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
167   then   then
168   for i in ${idedisks}   message+="\n"
169     message+=$"Optical disk drives:\n"
170     for i in ${ALL_CDROMS}
171   do   do
172   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
173   done   done
174   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
175   fi   fi
176    
177   # other devices   # other devices
178   run_hardware_detection   run_hardware_detection
179   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
180   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
181   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
182   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
183   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
184   esac   esac
185   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
186   then   then
187   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
188   fi   fi
189    
190   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
191  }  }
192    
193  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
194  {  {
195   local i   local i
196     local retval
197    
198   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
199   then   then
200   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
201   exit 1   exit 1
202   else   else
203     HDD=$(dialog_select_target_harddrive)
204   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
205   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
206   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
207   then   then
208   dialog_setup_hdd_info   dialog_setup_hdd_info
209   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
210   fi   fi
211   fi   fi
212  }  }
# Line 303  dialog_setup_hdd_partitions_manuell_flas Line 214  dialog_setup_hdd_partitions_manuell_flas
214  dialog_setup_hdd_partitions_auto()  dialog_setup_hdd_partitions_auto()
215  {  {
216   local i   local i
217     local retval
218    
219   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
220   then   then
221   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
222   exit 1   exit 1
223   else   else
224     HDD=$(dialog_select_target_harddrive)
225   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
226   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
227   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
228   then   then
229   dialog_setup_hdd_info_auto   dialog_setup_hdd_info_auto
230   dialog_setup_hdd_create_partitions   dialog_setup_hdd_create_partitions
# Line 339  dialog_setup_hdd_partitions_auto() Line 233  dialog_setup_hdd_partitions_auto()
233   fi   fi
234  }  }
235    
236  dialog_setup_hdd_create_partitions()  install_meter()
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 dialog_install_meter()  
237  {  {
238   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
239   do   do
# Line 380  dialog_install_meter() Line 246  dialog_install_meter()
246   return 0   return 0
247  }  }
248    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
249  dialog_main()  dialog_main()
250  {  {
251   METHOD=0   local method=0
252     local retval
253    
254   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
255   do   do
256   METHOD=$(dialog \   method=$(menubox $"Configuration:" \
257   --backtitle "${TITLE}" \   $"1:Install system" \
258   --no-cancel \   $"2:Show detected harddrives" \
259   --ok-label "Weiter" \   $"3:Exit and reboot" \
260   --stdout \   $"4:Exit and drop into a shell")
261   --menu "Konfiguration" 14 70 5 \   retval=$?
262   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
263   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
264   then   then
265   case ${METHOD} in   case ${method} in
266           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
267   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
268   "3") install_do_reboot ;;   "3") install_do_reboot ;;
269   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 445  run_hardware_detection() Line 281  run_hardware_detection()
281    
282   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
283    
284   # check for special devices/clients:   ## check for special devices/clients:
285   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
286   local removable=0   #local removable=0
287   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
288   then   #then
289   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
290   do   #do
291   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
292   then   #then
293   removable=1   #removable=1
294   fi   #fi
295   done   #done
296     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
297   # only add this for grub legacy, grub2 detect these settings on its own  
298   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
299   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
300   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
301   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
302   export SPECIALDEVICE="zotac_nvidia"   #then
303   else   #export SPECIALDEVICE="zotac_nvidia"
304   export SPECIALDEVICE="zotac_intel"   #else
305   fi   #export SPECIALDEVICE="zotac_intel"
306   fi   #fi
307     #fi
308    
309   # check for special devices/clients:   # check for special devices/clients:
310   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 496  run_hardware_detection() Line 333  run_hardware_detection()
333   fi   fi
334  }  }
335    
336    run_hardware_detection_disks()
337    {
338     local bootdev
339    
340     # all disks but exclude ramdisks
341     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
342     # remove the boot device from ALL_DISKS if it was an usbstick
343     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
344     then
345     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
346     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
347     fi
348     export ALL_CDROMS="$(get_hwinfo cdrom)"
349    }
350    
351  hdd_size_below_256mb()  hdd_size_below_256mb()
352  {  {
353   local hdd="$1"   local hdd="$1"
354   local size   local size
355   local retval   local retval
356   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
357    
358   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
359   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 530  setup_hdd_partitions_auto() Line 382  setup_hdd_partitions_auto()
382   fi   fi
383    
384   ## delete disk   ## delete disk
385   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
386    
387   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
388   then   then
# Line 576  EOF Line 428  EOF
428   fi   fi
429  }  }
430    
431  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
432  {  {
433   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
434    
435   ## hdds partitionieren manuell   ## hdds partitionieren manual
436   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
437  }  }
438    
439  setup_hdd_format()  setup_hdd_format()
440  {  {
441   mkswap ${SWAPHDD} || die   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
442  }  }
443    
444  install_mount_rootfs()  install_mount_rootfs()
445  {  {
446   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
447   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
  install -d ${INSTALLPATH}/boot || die  
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
448  }  }
449    
450  install_system_image()  install_system_image()
451  {  {
452   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   pushd ${INSTALLROOT} > /dev/null
453     tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
454     popd > /dev/null
455  }  }
456    
457  install_bootsector_chroot()  install_bootsector_chroot()
458  {  {
459   local my_roothdd   local my_roothdd
460   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
461   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
462    
463   # check for grub2   # check for grub2
464   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
465   then   then
466   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
467   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
468   then   then
469   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
470   fi   fi
471    
472   # set kernelopts   # set kernelopts
473   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
474   then   then
475   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
476   else   else
477   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
478   fi   fi
479   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
480   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
481   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
482   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
483    
484   # grub-legacy   # grub-legacy
485   else   else
486   ### grubconf schreiben   ### grubconf schreiben
487   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
488    
489   #for alx only   #for alx only
490   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
491   then   then
492   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
493   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
494   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
495   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
496   fi   fi
# Line 680  install_bootsector_chroot() Line 507  install_bootsector_chroot()
507   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
508   fi   fi
509    
510   : > ${grubconf} || die   : > ${grubconf} || dialog_die
511   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
512   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
513   # using current root password   # using current root password
514   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
515    
516   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
517   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
518   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
519   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
520   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
521   if is_initrd_supported   if is_initrd_supported
522   then   then
523   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
524   fi   fi
525    
526   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
527   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
528   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
529   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
530   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
531   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
532   if is_initrd_supported   if is_initrd_supported
533   then   then
534   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
535   fi   fi
536    
537   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
538   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
539   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
540   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
541   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
542   if is_initrd_supported   if is_initrd_supported
543   then   then
544   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
545   fi   fi
546    
547   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
548   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
549  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
550  root (hd0,0)  root (hd0,0)
551  setup (hd0)  setup (hd0)
# Line 728  exit 0 Line 555  exit 0
555  CHROOTEOF  CHROOTEOF
556   fi   fi
557    
558   ## enters chroot   ## enter chroot
559   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
560   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
561   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
562   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
563   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
564   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
565   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
566   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
567  }  }
568    
569  is_initrd_supported()  is_initrd_supported()
570  {  {
571   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
572   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
573   return 1   return 1
574  }  }
575    
# Line 773  install_initrd_chroot() Line 600  install_initrd_chroot()
600   fi   fi
601    
602   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
603   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
604   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
605    
606   # install an appropriate viafb.conf   # install an appropriate viafb.conf
607   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
608    
609   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
610   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
611    
612   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
613  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
614  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
615  exit 0  exit 0
616  CHROOTEOF  CHROOTEOF
617    
618   ## enters chroot   ## enters chroot
619   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
620   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
621   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
622   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
623   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
624   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
625   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
626   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
627  }  }
628    
629  is_uuid_supported()  is_uuid_supported()
630  {  {
631   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
632   then   then
633   # only detect uuids if supported   # only detect uuids if supported
634   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 820  get_uuid() Line 647  get_uuid()
647   local TYPE   local TYPE
648    
649   local dev="$1"   local dev="$1"
650   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
651    
652   # check if given device is already an UUID   # check if given device is already an UUID
653   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 837  install_system_settings() Line 664  install_system_settings()
664   # schreibe fstab   # schreibe fstab
665   if is_uuid_supported   if is_uuid_supported
666   then   then
667   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
668   else   else
669   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
670   fi   fi
671   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
672   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
673   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
674   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
675    
676   # install network config skeleton   # install network config skeleton
677   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
678    
679   # intel framebufer quirk   # intel framebufer quirk
680   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 859  install_system_settings() Line 684  install_system_settings()
684   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
685   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
686   then   then
687   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
688   fi   fi
689   fi   fi
690   fi   fi
691  }  }
692    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
693  install_umount_rootfs()  install_umount_rootfs()
694  {  {
695   cd /   umount ${INSTALLROOT}/boot || dialog_die
696   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT} || dialog_die
  umount ${INSTALLPATH} || die  
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
697  }  }
698    
699  install_do_reboot()  install_do_reboot()
# Line 905  run_install_normal() Line 709  run_install_normal()
709  {  {
710   dialog_hardware_detection   dialog_hardware_detection
711    
712   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
713   dialog_setup_hdd_format   dialog_setup_hdd_format
714   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
715   install_mount_rootfs   install_mount_rootfs
716   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
717    
718   dialog_install_settings   dialog_install_settings
719   sleep 1   sleep 1
720   install_system_settings   install_system_settings
721     dialog_install_initrd
722   install_initrd_chroot   install_initrd_chroot
723    
724   dialog_install_bootsector   dialog_install_bootsector
# Line 923  run_install_normal() Line 728  run_install_normal()
728   dialog_install_successful   dialog_install_successful
729  }  }
730    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
731  run_install_auto()  run_install_auto()
732  {  {
733   dialog_hardware_detection   dialog_hardware_detection
734    
735   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
736   dialog_setup_hdd_format   dialog_setup_hdd_format
737   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
738   install_mount_rootfs_flash   install_mount_rootfs
739   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
740    
741   dialog_install_settings   dialog_install_settings
742   sleep 1   sleep 1
743   install_system_settings_flash   install_system_settings
744     dialog_install_initrd
745   install_initrd_chroot   install_initrd_chroot
746    
747   dialog_install_bootsector   dialog_install_bootsector
748   install_bootsector_chroot   install_bootsector_chroot
749    
750   install_umount_rootfs_flash   install_umount_rootfs
751   dialog_install_successful   dialog_install_successful
752  }  }
753    
754    # set some proper traps
755    trap "trap_exit" SIGINT SIGQUIT
756    
757  dialog_main  dialog_main
758    
759  exit 0  exit 0

Legend:
Removed from v.2323  
changed lines
  Added in v.2434